* Standard defines and routines for the TI99/4A Home Computer
* to use with the Editor/Assembler module.
*
       TITL 'Standard defines and routines for the TI99/4A'
       
       IDT  'ASMUP'

*      DEF  GPLLNK,XMLLNK,DSRLNK,LOADER,KSCAN
       DEF  KSCAN,VSBW,VMBW,VSBR,VMBR,VWTR  
       DEF  UTLTAB,FSTHI,LSTHI,FSTLOW,LSTLOW,CHKSAV
       DEF  FLGPTR,SVGPRT,SAVCRU,SAVENT,SAVLEN,SAVPAB,SAVVER
       DEF  VDPRD,VDPSTA,VDPWD,VDPWA,GRMRD,GRMRA,GRMWD,GRMWA 
       DEF  PAD,GPLWS,SOUND,SPCHRD,SPCHWT,SCAN  

*GPLLNK EQU  >2100
*XMLLNK EQU  >2104
*KSCAN  EQU  >2108
*VSBW   EQU  >210C
*VMBW   EQU  >2110
*VSBR   EQU  >2114
*VMBR   EQU  >2118
*VWTR   EQU  >211C
*DSRLNK EQU  >2120
*LOADER EQU  >2124
UTLTAB EQU  >2022
FSTHI  EQU  >2024
LSTHI  EQU  >2026
FSTLOW EQU  >2028
LSTLOW EQU  >202A
CHKSAV EQU  >202C
FLGPTR EQU  >202E
SVGPRT EQU  >2030
SAVCRU EQU  >2032
SAVENT EQU  >2034
SAVLEN EQU  >2036
SAVPAB EQU  >2038
SAVVER EQU  >203A
VDPRD  EQU  >8800
VDPSTA EQU  >8802
VDPWD  EQU  >8C00
VDPWA  EQU  >8C02
GRMRD  EQU  >9800
GRMRA  EQU  >9802
GRMWD  EQU  >9C00
GRMWA  EQU  >9C02
PAD    EQU  >8300
GPLWS  EQU  >83E0
SOUND  EQU  >8400
SPCHRD EQU  >9000
SPCHWT EQU  >9400
SCAN   EQU  >000E

HOB	EQU	0	High order byte offset
LOB	EQU	1	Low order byte offset

OFR0	EQU	0	Register offsets from workspace
OFR1	EQU	2
OFR2	EQU	4
OFR3	EQU	6
OFR4	EQU	8
OFR5	EQU	10
OFR6	EQU	12
OFR7	EQU	14
OFR8	EQU	16
OFR9	EQU	18
OFR10	EQU	20
OFR11	EQU	22
OFR12	EQU	24
OFR13	EQU	26
OFR14	EQU	28
OFR15	EQU	30

*UTLWS	BSS	32
UTLWS	EQU	>2094

KSCAN	DATA	UTLWS,KSCAN$
KSCAN$	LWPI	GPLWS
	MOV	R11,@UTLWS+OFR11
	BL	@SCAN
	LWPI	UTLWS
	MOV	R11,@GPLWS+OFR11
	RTWP
	
VDPW	LI	R1,>4000
	JMP	VDP$1
VDPR	CLR	R1
VDP$1	MOV	*R13,R2
	MOVB	@UTLWS+OFR2+LOB,@VDPWA
	SOC	R1,R2
	MOVB	R2,@VDPWA
	MOV	@2(R13),R1
	MOV	@4(R13),R2
	RT
	
VSBW	DATA	UTLWS,VSBW$
VSBW$	BL	@VDPW
	MOVB	@2(R13),@VDPWD
	RTWP
	
VMBW	DATA	UTLWS,VMBW$
VMBW$	BL	@VDPW
VMBW$1	MOVB	*R1+,@VDPWD
	DEC	R2
	JNE	VMBW$1
	RTWP

VSBR	DATA	UTLWS,VSBR$
VSBR$	BL	@VDPR
	MOVB	@VDPRD,@2(R13)
	RTWP
	
VMBR	DATA	UTLWS,VMBR$
VMBR$	BL	@VDPR
VMBR$1	MOVB	@VDPRD,*R1+
	DEC	R2
	JNE	VMBR$1
	RTWP
	
VWTR	DATA	UTLWS,VWTR$	
VWTR$	MOV	*R13,R1
	MOVB	@1(R13),@VDPWA
	ORI	R1,>8000
	MOVB	R1,@VDPWA
	RTWP

	END