ASM990 1.0.6     ASMUP                      Wed Apr 02 17:36:57 2008 Page 0001
Standard defines and routines for the TI99/4A

                            1 * Standard defines and routines for the TI99/4A Home Computer
                            2 * to use with the Editor/Assembler module.
                            3 *
                            4        TITL 'Standard defines and routines for the TI99/4A'
                            5        
                            6        IDT  'ASMUP'
                            7 
                            8 *      DEF  GPLLNK,XMLLNK,DSRLNK,LOADER,KSCAN
                            9        DEF  KSCAN,VSBW,VMBW,VSBR,VMBR,VWTR  
                           10        DEF  UTLTAB,FSTHI,LSTHI,FSTLOW,LSTLOW,CHKSAV
                           11        DEF  FLGPTR,SVGPRT,SAVCRU,SAVENT,SAVLEN,SAVPAB,SAVVER
                           12        DEF  VDPRD,VDPSTA,VDPWD,VDPWA,GRMRD,GRMRA,GRMWD,GRMWA 
                           13        DEF  PAD,GPLWS,SOUND,SPCHRD,SPCHWT,SCAN  
                           14 
                           15 *GPLLNK EQU  >2100
                           16 *XMLLNK EQU  >2104
                           17 *KSCAN  EQU  >2108
                           18 *VSBW   EQU  >210C
                           19 *VMBW   EQU  >2110
                           20 *VSBR   EQU  >2114
                           21 *VMBR   EQU  >2118
                           22 *VWTR   EQU  >211C
                           23 *DSRLNK EQU  >2120
                           24 *LOADER EQU  >2124
                   2022    25 UTLTAB EQU  >2022
                   2024    26 FSTHI  EQU  >2024
                   2026    27 LSTHI  EQU  >2026
                   2028    28 FSTLOW EQU  >2028
                   202A    29 LSTLOW EQU  >202A
                   202C    30 CHKSAV EQU  >202C
                   202E    31 FLGPTR EQU  >202E
                   2030    32 SVGPRT EQU  >2030
                   2032    33 SAVCRU EQU  >2032
                   2034    34 SAVENT EQU  >2034
                   2036    35 SAVLEN EQU  >2036
                   2038    36 SAVPAB EQU  >2038
                   203A    37 SAVVER EQU  >203A
                   8800    38 VDPRD  EQU  >8800
                   8802    39 VDPSTA EQU  >8802
                   8C00    40 VDPWD  EQU  >8C00
                   8C02    41 VDPWA  EQU  >8C02
                   9800    42 GRMRD  EQU  >9800
                   9802    43 GRMRA  EQU  >9802
                   9C00    44 GRMWD  EQU  >9C00
                   9C02    45 GRMWA  EQU  >9C02
                   8300    46 PAD    EQU  >8300
                   83E0    47 GPLWS  EQU  >83E0
                   8400    48 SOUND  EQU  >8400
                   9000    49 SPCHRD EQU  >9000
                   9400    50 SPCHWT EQU  >9400
                   000E    51 SCAN   EQU  >000E
                           52 
                   0000    53 HOB     EQU     0       High order byte offset
                   0001    54 LOB     EQU     1       Low order byte offset
                           55 
                   0000    56 OFR0    EQU     0       Register offsets from workspace
                   0002    57 OFR1    EQU     2
                   0004    58 OFR2    EQU     4
                   0006    59 OFR3    EQU     6
                   0008    60 OFR4    EQU     8
                   000A    61 OFR5    EQU     10
ASM990 1.0.6     ASMUP                      Wed Apr 02 17:36:57 2008 Page 0002
Standard defines and routines for the TI99/4A

                   000C    62 OFR6    EQU     12
                   000E    63 OFR7    EQU     14
                   0010    64 OFR8    EQU     16
                   0012    65 OFR9    EQU     18
                   0014    66 OFR10   EQU     20
                   0016    67 OFR11   EQU     22
                   0018    68 OFR12   EQU     24
                   001A    69 OFR13   EQU     26
                   001C    70 OFR14   EQU     28
                   001E    71 OFR15   EQU     30
                           72 
                           73 *UTLWS  BSS     32
                   2094    74 UTLWS   EQU     >2094
                           75 
 0000  2094  0004'         76 KSCAN   DATA    UTLWS,KSCAN$
 0004  02E0  83E0          77 KSCAN$  LWPI    GPLWS
 0008  C80B  20AA          78         MOV     R11,@UTLWS+OFR11
 000C  06A0  000E          79         BL      @SCAN
 0010  02E0  2094          80         LWPI    UTLWS
 0014  C80B  83F6          81         MOV     R11,@GPLWS+OFR11
 0018  0380                82         RTWP
                           83         
 001A  0201  4000          84 VDPW    LI      R1,>4000
 001E  1001                85         JMP     VDP$1
 0020  04C1                86 VDPR    CLR     R1
 0022  C09D                87 VDP$1   MOV     *R13,R2
 0024  D820  2099  8C02    88         MOVB    @UTLWS+OFR2+LOB,@VDPWA
 002A  E081                89         SOC     R1,R2
 002C  D802  8C02          90         MOVB    R2,@VDPWA
 0030  C06D  0002          91         MOV     @2(R13),R1
 0034  C0AD  0004          92         MOV     @4(R13),R2
 0038  045B                93         RT
                           94         
 003A  2094  003E'         95 VSBW    DATA    UTLWS,VSBW$
 003E  06A0  001A'         96 VSBW$   BL      @VDPW
 0042  D82D  0002  8C00    97         MOVB    @2(R13),@VDPWD
 0048  0380                98         RTWP
                           99         
 004A  2094  004E'        100 VMBW    DATA    UTLWS,VMBW$
 004E  06A0  001A'        101 VMBW$   BL      @VDPW
 0052  D831  8C00         102 VMBW$1  MOVB    *R1+,@VDPWD
 0056  0602               103         DEC     R2
 0058  16FC               104         JNE     VMBW$1
 005A  0380               105         RTWP
                          106 
 005C  2094  0060'        107 VSBR    DATA    UTLWS,VSBR$
 0060  06A0  0020'        108 VSBR$   BL      @VDPR
 0064  DB60  8800  0002   109         MOVB    @VDPRD,@2(R13)
 006A  0380               110         RTWP
                          111         
 006C  2094  0070'        112 VMBR    DATA    UTLWS,VMBR$
 0070  06A0  0020'        113 VMBR$   BL      @VDPR
 0074  DC60  8800         114 VMBR$1  MOVB    @VDPRD,*R1+
 0078  0602               115         DEC     R2
 007A  16FC               116         JNE     VMBR$1
 007C  0380               117         RTWP
                          118         
 007E  2094  0082'        119 VWTR    DATA    UTLWS,VWTR$     
 0082  C05D               120 VWTR$   MOV     *R13,R1
 0084  D82D  0001  8C02   121         MOVB    @1(R13),@VDPWA
 008A  0261  8000         122         ORI     R1,>8000
ASM990 1.0.6     ASMUP                      Wed Apr 02 17:36:57 2008 Page 0003
Standard defines and routines for the TI99/4A

 008E  D801  8C02         123         MOVB    R1,@VDPWA
 0092  0380               124         RTWP
                          125 
                          126         ENDASM990 1.0.6     ASMUP                      Wed Apr 02 17:36:57 2008 Page 0004
Standard defines and routines for the TI99/4A

 CHKSAV   202CG  FLGPTR   202EG  FSTHI    2024G  FSTLOW   2028G  GPLWS    83E0G 
 GRMRA    9802G  GRMRD    9800G  GRMWA    9C02G  GRMWD    9C00G  HOB      0000  
 KSCAN    0000G  KSCAN$   0004'  LOB      0001   LSTHI    2026G  LSTLOW   202AG 
 OFR0     0000   OFR1     0002   OFR10    0014   OFR11    0016   OFR12    0018  
 OFR13    001A   OFR14    001C   OFR15    001E   OFR2     0004   OFR3     0006  
 OFR4     0008   OFR5     000A   OFR6     000C   OFR7     000E   OFR8     0010  
 OFR9     0012   PAD      8300G  R0       0000   R1       0001   R10      000A  
 R11      000B   R12      000C   R13      000D   R14      000E   R15      000F  
 R2       0002   R3       0003   R4       0004   R5       0005   R6       0006  
 R7       0007   R8       0008   R9       0009   SAVCRU   2032G  SAVENT   2034G 
 SAVLEN   2036G  SAVPAB   2038G  SAVVER   203AG  SCAN     000EG  SOUND    8400G 
 SPCHRD   9000G  SPCHWT   9400G  SVGPRT   2030G  UTLTAB   2022G  UTLWS    2094  
 VDP$1    0022'  VDPR     0020'  VDPRD    8800G  VDPSTA   8802G  VDPW     001A' 
 VDPWA    8C02G  VDPWD    8C00G  VMBR     006CG  VMBR$    0070'  VMBR$1   0074' 
 VMBW     004AG  VMBW$    004E'  VMBW$1   0052'  VSBR     005CG  VSBR$    0060' 
 VSBW     003AG  VSBW$    003E'  VWTR     007EG  VWTR$    0082' 

asm990: 0 Errors in assembly
